//+------------------------------------------------------------------+
//|                                                       %r nrp.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum    -100
#property indicator_maximum    0
#property indicator_buffers    5
#property indicator_color1     MediumOrchid
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_levelcolor Gold

//
//
//
//
//

extern int    WprPeriod              = 50;
extern double levelOb                = -20;
extern double levelOs                = -80;
extern color  OverSoldColor          = DeepSkyBlue; 
extern color  OverBoughtColor        = Red; 
extern bool   verticalLinesVisible   = false;
extern string verticalLinesID        = "wpr Lines";
extern color  verticalLinesUpColor   = DeepSkyBlue;
extern color  verticalLinesDownColor = PaleVioletRed;
extern int    verticalLinesStyle     = STYLE_DOT;
extern int    verticalLinesWidth     = 0;

//
//
//
//
//

double wpr[];
double wprUpa[];
double wprUpb[];
double wprDna[];
double wprDnb[];
double value[];
double trend[];

//
//
//
//
//

int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,wpr);
   SetIndexBuffer(1,wprUpa); SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,OverSoldColor);
   SetIndexBuffer(2,wprUpb); SetIndexStyle(2,DRAW_LINE,EMPTY,EMPTY,OverSoldColor);
   SetIndexBuffer(3,wprDna); SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,OverBoughtColor);
   SetIndexBuffer(4,wprDnb); SetIndexStyle(4,DRAW_LINE,EMPTY,EMPTY,OverBoughtColor);
   SetIndexBuffer(5,value);
   SetIndexBuffer(6,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   IndicatorShortName( " %R ("+WprPeriod+")");
return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
  
//+------------------------------------------------------------------+
//| Williams? Percent Range                                          |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //
   
   if (value[limit]== 1) CleanPoint(limit,wprUpa,wprUpb);
   if (value[limit]==-1) CleanPoint(limit,wprDna,wprDnb);       
   for (i=limit; i>=0; i--)
   {
       double hi   = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
       double lo   =  Low[iLowest(NULL, 0,MODE_LOW, WprPeriod,i)];
       if (hi!=lo)      
            wpr[i] = -100*(hi - Close[i]) / (hi - lo);
       else wpr[i] = 0;
       
       //
       //
       //
       //
       //
       
       wprUpa[i] = EMPTY_VALUE;
       wprUpb[i] = EMPTY_VALUE;
       wprDna[i] = EMPTY_VALUE;
       wprDnb[i] = EMPTY_VALUE;
       value[i]  = value[i+1];
       
       if (wpr[i]>levelOs && wpr[i]<levelOb) value[i] = 0;
       if (wpr[i]>levelOb)                   value[i] =-1;
       if (wpr[i]<levelOs)                   value[i] = 1;
       if (value[i] ==  1) PlotPoint(i,wprUpa,wprUpb,wpr);
       if (value[i] == -1) PlotPoint(i,wprDna,wprDnb,wpr);
       
       //
       //
       //
       //
       //
       
       trend[i] = 0;
           if (wpr[i]>levelOb) trend[i] = 1;
           if (wpr[i]<levelOs) trend[i] =-1;
           manageLines(i);           
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageLines(int i)
{
   if (verticalLinesVisible )
   {
         deleteLine(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i+1] == -1 && trend[i] !=-1) drawLine(i,verticalLinesUpColor);
            if (trend[i+1] ==  1 && trend[i] != 1) drawLine(i,verticalLinesDownColor);
         }
   }
}               

//
//
//
//
//

void drawLine(int i,color theColor)
{
   string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void deleteLine(datetime time)
{
   string lookFor = verticalLinesID+":"+time; ObjectDelete(lookFor);
}


